summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorMichael Vogt <mvo@ubuntu.com>2014-09-17 22:18:19 +0200
committerMichael Vogt <mvo@ubuntu.com>2014-09-17 22:18:19 +0200
commitd667daf3e6ba5bfc7feb8a5ed0a0bd2d1febde4d (patch)
treedccdc5cb6ec9abb557f9df152b76693efdb58c41 /test
parent0e510b0f46350480852b22b966601aaae8cef52f (diff)
parente438bafe7d578a04837c520ca5d69f38a6b993cf (diff)
Merge branch 'debian/sid' into ubuntu/master
Conflicts: debian/changelog
Diffstat (limited to 'test')
-rwxr-xr-xtest/integration/test-apt-update-file34
1 files changed, 34 insertions, 0 deletions
diff --git a/test/integration/test-apt-update-file b/test/integration/test-apt-update-file
new file mode 100755
index 000000000..e267c71da
--- /dev/null
+++ b/test/integration/test-apt-update-file
@@ -0,0 +1,34 @@
+#!/bin/sh
+#
+# Ensure that we do not modify file:/// uris (regression test for
+# CVE-2014-0487
+#
+set -e
+
+TESTDIR=$(readlink -f $(dirname $0))
+. $TESTDIR/framework
+
+setupenvironment
+configarchitecture "amd64"
+configcompression 'bz2' 'gz'
+
+insertpackage 'unstable' 'foo' 'all' '1.0'
+
+umask 022
+setupaptarchive --no-update
+
+# ensure the archive is not writable
+chmod 550 aptarchive/dists/unstable/main/binary-amd64
+
+testsuccess aptget update -qq
+testsuccess aptget update -qq
+aptget update -qq -o Debug::pkgAcquire::Auth=1 2> output.log
+
+# ensure that the hash of the uncompressed file was verified even on a local
+# ims hit
+canary="SHA512:$(bzcat aptarchive/dists/unstable/main/binary-amd64/Packages.bz2 | sha512sum |cut -f1 -d' ')"
+grep -q "RecivedHash: $canary" output.log
+
+
+# the cleanup should still work
+chmod 750 aptarchive/dists/unstable/main/binary-amd64